/*
 *  Project: floop
 *  Description: A jQuery plugin to display a frames sequence as a browsable animation. Mainly used to simulate 3D roation in a browser.
 *  Author: Sébastien Boulanger
 *  License: Creative Commons
 *  Version: 0.6.3
 */
(function(e,t,n,r){function d(t,n){this.element=e(t);this.options=e.extend({},s,n);this._defaults=s;this._name=i;this.filename={complete:"",path:"",extension:"",noextension:"",sequence:"",number:0,name:""};this.minPic=0;this.maxPic=0;this.numOfPics=0;this.dimensions={width:0,height:0};this.$Container="";this.$Images="";this.$DragIcon="";this.$StatusBar="";this.$ProgressBar="";this.$ProgressValue="";this.progress=0;this.autoplayItv=null;this.autoplayRepeats=0;this.locked=false;this.init()}var i="floop",s={range:"0-100",width:0,height:0,steps:1,reverse:false,axis:"y",callToAction:true,className:"",autoplay:{},onBegin:function(){},onProgress:function(){},onComplete:function(){},onNext:function(){},onPrev:function(){},onStart:function(){},onStop:function(){}},o="floop_begin",u="floop_progress",a="floop_complete",f="floop_next",l="floop_prev",c="floop_start",h="floop_stop",p="";d.prototype={trigger:function(t,r){e(n).trigger(t);if(e.isFunction(r)){r.call(this)}},init:function(){this.trigger(o,this.options.onBegin);this.execFloop();p.elements.push(this)},execFloop:function(){this.dimensions.width=0===this.options.width?parseInt(this.element.get(0).width):parseInt(this.options.width);this.dimensions.height=0===this.options.height?parseInt(this.element.get(0).height):parseInt(this.options.height);this.minPic=parseInt(this.options.range.slice(0,1+this.options.range.indexOf("-")));this.maxPic=parseInt(this.options.range.slice(1+this.options.range.indexOf("-"),this.options.range.length));this.numOfPics=Math.ceil(this.maxPic/this.options.steps);this.setFilename();this.prepareHtml();this.loadPictures()},prepareHtml:function(){this.element.css({position:"relative",zIndex:"1"});this.$Container=e('<div class="floop_container '+" "+this.options.axis+" "+this.options.className+'" style="overflow:hidden;width:'+this.dimensions.width+"px;height:"+this.dimensions.height+'px;"></div>');this.$Images=e('<div class="floop_images" style="overflow:hidden;width:'+this.dimensions.width+"px;height:"+this.dimensions.height+'px;"></div>');this.element.wrap(this.$Images);this.$Images=e(this.element.parent());this.$Images.wrap(this.$Container);this.$Container=e(this.$Images.parent());this.$StatusBar=e('<div style="width:'+this.dimensions.width+'px;" class="floop_status"></div>');this.$Images.after(this.$StatusBar);this.$ProgressValue=e('<div style="width:0%;" class="floop_progress_value"></div>');this.$ProgressBar=e('<div class="floop_progress"></div>');this.$StatusBar.append(this.$ProgressBar);this.$ProgressBar.append(this.$ProgressValue);this.$DragIcon=e('<div style="margin-top:'+(this.dimensions.height/2-11)+"px;margin-left:"+(this.dimensions.width/2-15)+'px;" class="floop_drag_icon '+this.options.axis+' "></div>')},animateDragIcon:function(){var t={},n={},r="y"===this.options.axis?"marginLeft":"marginTop";t[r]="-=2px";n[r]="+=2px";this.$DragIcon.animate(t,200).animate(n,200,e.proxy(function(){this.animateDragIcon()},this))},setFilename:function(){regSequence=new RegExp("[0-9]+$");regFilenumber=new RegExp("^0*");this.filename.complete=this.element.attr("src").slice(1+this.element.attr("src").lastIndexOf("/"),this.element.attr("src").length);this.filename.path=this.element.attr("src").slice(0,1+this.element.attr("src").lastIndexOf("/"));this.filename.extension=this.filename.complete.slice(1+this.filename.complete.lastIndexOf("."),this.filename.complete.length);this.filename.noextension=this.filename.complete.slice(0,this.filename.complete.lastIndexOf("."));this.filename.sequence=this.filename.noextension.match(regSequence)[0];this.filename.number=parseInt(this.filename.sequence.replace(regFilenumber,""));this.filename.number=this.filename.number?this.filename.number:0;this.filename.name=this.filename.noextension.slice(0,this.filename.noextension.lastIndexOf(this.filename.sequence))},loadPictures:function(){var t="";var n="0";var r="";var i=[];var s="";for(var o=0;o<=this.numOfPics;o++){t=""+(this.minPic+o*this.options.steps);while(t.length<this.filename.sequence.length){t=n.concat(t)}s=this.filename.path+this.filename.name+t+"."+this.filename.extension;r=e('<img style="display:none;" />');r.attr("src",s).on("load",e.proxy(function(e){i.push(e.currentTarget);this.progress++;this.incrementLoad();this.trigger(u,this.options.onProgress);if(this.progress===this.numOfPics){this.appendPictures(i)}},this))}},appendPictures:function(t){this.$StatusBar.remove();for(var n=0;n<=this.numOfPics;n++){var r=t[n];var i="";var s="0";i=""+(this.minPic+n*this.options.steps);while(i.length<this.filename.sequence.length){i=s.concat(i)}file=this.filename.path+this.filename.name+i+"."+this.filename.extension;for(var o=0;o<=this.numOfPics;o++){if(e(t[o]).attr("src")===file){if(-1!=e(t[o]).attr("src").indexOf(this.element.attr("src"))){this.$Images.append(this.element)}else{this.$Images.append(t[o])}}}}this.options.callToAction?this.$Images.before(this.$DragIcon):null;this.animateDragIcon();this.setControls()},incrementLoad:function(){this.$ProgressValue.css("width",Math.ceil(this.progress/this.numOfPics*100)+"%")},setControls:function(){this.$Images.on("mouseover",e.proxy(function(t){this.$DragIcon.remove();e(t.currentTarget).off("mouseover")},this));var t=0,n="pageX";this.$Images.draggable({iframeFix:true,grid:[999999,999999],drag:e.proxy(function(e,r){!this.options.autoplay.locked?this.stopAutoplay():false;"x"===this.options.axis?n="pageY":"pageX";if(t>e.originalEvent[n]){if(0===e.originalEvent[n]%3){this.options.reverse?this.displayNext():this.displayPrev()}}if(t<e.originalEvent[n]){if(0===e.originalEvent[n]%3){this.options.reverse?this.displayPrev():this.displayNext()}}t=e.originalEvent[n]},this)});if(this.options.autoplay){this.startAutoplay()}this.trigger(a,this.options.onComplete)},startAutoplay:function(){this.trigger(c,this.options.onStart);if(this.options.autoplay.locked){this.locked="true"}this.options.autoplay.speed=this.options.autoplay.speed?this.options.autoplay.speed:25;this.options.autoplay.repeat=this.options.autoplay.repeat?this.options.autoplay.repeat:0;var t=Math.ceil(1e3/this.options.autoplay.speed);var n=0;if("infinity"!==this.options.autoplay.repeat){n=this.options.autoplay.repeat*this.numOfPics}this.autoplayItv=setInterval(e.proxy(function(){if("infinity"===this.options.autoplay.repeat||n>this.autoplayRepeats){this.autoplayRepeats++;this.options.reverse?this.displayPrev(true):this.displayNext(true)}else{this.stopAutoplay()}},this),t)},stopAutoplay:function(){this.autoplayRepeats=0;clearInterval(this.autoplayItv);this.autoplayItv=null;this.locked=false;this.trigger(h,this.options.onStop)},displayPrev:function(e){if(e||!this.locked){this.trigger(l,this.options.onPrev);if(this.element.prev().get(0)){this.element.css("display","none");this.element.prev().css("display","block");this.element=this.element.prev()}else{this.element.css("display","none");this.$Images.find("img:last-child").css("display","block");this.element=this.$Images.find("img:last-child")}}},displayNext:function(e){if(e||!this.locked){this.trigger(f,this.options.onNext);if(this.element.next().get(0)){this.element.css("display","none");this.element.next().css("display","block");this.element=this.element.next()}else{this.element.css("display","none");this.$Images.find("img:first-child").css("display","block");this.element=this.$Images.find("img:first-child")}}}};p=e.fn[i]=e[i]=function(e){var t=this;e=e||{};return t};p.elements=[];p.getElement=function(t){var n=e(t),r=this.elements.length,i=0;for(i;i<r;i++){if(this.elements[i].element.parent().get(0)===n.parent().get(0)){return this.elements[i]}}};p.next=function(e){var t=this.getElement(e);t.displayNext()};p.prev=function(e){var t=this.getElement(e);t.displayPrev()};p.play=function(e){var t=this.getElement(e);t.startAutoplay()};p.stop=function(e){var t=this.getElement(e);t.stopAutoplay()};e.fn[i]=function(t){return this.each(function(){if(!e.data(this,"plugin_"+i)){e.data(this,"plugin_"+i,new d(this,t))}})}})(jQuery,window,document)